//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2021 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

package db

import (
	"github.com/semi-technologies/weaviate/adapters/repos/db/helpers"
	"github.com/semi-technologies/weaviate/entities/schema"
)

// VectorIndex is anything that indexes vectors effieciently. For an example
// look at ./vector/hsnw/index.go
type VectorIndex interface {
	Add(id uint64, vector []float32) error
	Delete(id uint64) error
	SearchByVector(vector []float32, k int, allow helpers.AllowList) ([]uint64, error)
	UpdateUserConfig(updated schema.VectorIndexConfig) error
	Drop() error
}
